import { whenElse } from '@genesislcap/foundation-utils';
import { html, ref, when } from '@microsoft/fast-element';
import { TabsOrientation } from '@microsoft/fast-foundation';
import { classNames } from '@microsoft/fast-web-utilities';
import { getPrefix } from '../utils';
export const getPrefixedStepperTab = (prefix) => html `
  ${whenElse((x) => x.orientation === TabsOrientation.vertical, html `
        <${prefix}-tree-item ${ref('treeItem')} 
        class=${(x) => classNames('tree-item', ['cursor-pointer', x.showCursorPointer])}
        @click="${(x, c) => x.$emit('tab-clicked', x.tabPosition - 1)}">
          ${when((x) => x.completed, html `
              <${prefix}-icon
                name="check-circle"
                variant="regular"
                size="lg"
                class="stepper-icon completed-icon"
              ></${prefix}-icon>
            `)}
          ${when((x) => x.error, html `
              <${prefix}-icon
                name="times-circle"
                variant="regular"
                size="lg"
                class="stepper-icon error-icon"
              ></${prefix}-icon>
            `)}
          <slot></slot>
        </${prefix}-tree-item>
      `, html `
      <div class=${(x) => classNames('step-container', ['selected', x.selected])}>
        <div
          class=${(x) => classNames('step-number-container', ['cursor-pointer', x.showCursorPointer])}
          @click="${(x) => x.$emit('tab-clicked', x.tabPosition - 1)}"
        >
          ${when((x) => !x.hideStepNumber, html `
              <span class="step-number">${(x) => x.tabPosition}</span>
            `)}
          <slot class="step-title"></slot>
        </div>
        ${when((x) => !x.isLast, html `
                <${prefix}-icon
                  class="stepper-icon angle-icon"
                  name="angle-right"
                  variant="solid"
                  size="lg"
                ></${prefix}-icon>
              `)}
      </div>
    `)}
`;
export const foundationStepperTabTemplate = html `
  ${(x) => getPrefixedStepperTab(getPrefix(x))}
`;
